/*
 * Copyright (C) <2002-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * conf.h - compactdsl configuration header
 * ----------------------------------------
 *
 * Initial Version	Thu Mar 14 12:49:12 CET 2002 - jse
 * Written
 */

#ifndef _INC_compactdsl_conf_h_
#define _INC_compactdsl_conf_h_

/* ************************************************************************** */
/* *** HARDWARE REVISIONS *************************************************** */

/* Define supported hardware revisions */
#if defined(PROJECT_DAVOS44DSL) || defined(PROJECT_DAVOS44IAD) || defined(PROJECT_XI524)
#define INCLUDE_HWID_DAVOS
#undef INCLUDE_HWREV_A
#define INCLUDE_HWREV_PB2

#elif defined(PROJECT_T240)
#define INCLUDE_HWID_T240
#define INCLUDE_HWREV_V2_0

#elif defined(PROJECT_T444)
#define INCLUDE_HWID_T444
#define INCLUDE_HWREV_V2_0

#elif defined(PROJECT_K800)
#define INCLUDE_HWID_K800
#define INCLUDE_HWREV_K800_0

#elif
#error UNKNOWN PROJECT
#endif



/* ************************************************************************** */
/* *** ETHERNET ************************************************************* */

/* Define which units to be included */
#if defined(PROJECT_DAVOS44DSL) || defined(PROJECT_DAVOS44IAD)
#define	INCLUDE_HW_ETH_MAC0
#define	INCLUDE_HW_ETH_MAC1
#define	INCLUDE_HW_ETH_MAC2
#define	INCLUDE_HW_ETH_MAC3

#elif defined(PROJECT_XI524)
#define	INCLUDE_HW_ETH_MAC0
#define	INCLUDE_HW_ETH_MAC1
#define	INCLUDE_HW_ETH_MAC2

#elif defined(PROJECT_T240) || defined(PROJECT_T444)
#define	INCLUDE_HW_ETH_MAC2
#define	INCLUDE_HW_ETH_MAC3

#elif defined(PROJECT_K800)
#endif


/* Define supported phy's */
#if defined(PROJECT_DAVOS44DSL) || defined(PROJECT_DAVOS44IAD)
#define INCLUDE_HW_PHY_AMD79C901
#define INCLUDE_HW_PHY_AC104QF

#elif defined(PROJECT_XI524)
#define INCLUDE_HW_PHY_AC104QF

#elif defined(PROJECT_T240) || defined(PROJECT_T444)
#define INCLUDE_HW_PHY_KS8721B
#define INCLUDE_HW_PHY_NOPHY

#elif defined(PROJECT_K800)
#endif



/* ************************************************************************** */
/* *** FEATURES ************************************************************* */

/* hardware setup */
#if defined(PROJECT_T240) || defined(PROJECT_T444)
#define INCLUDE_HW_RTC_HT1381
#endif

#if !defined(PROJECT_VARIANT_HW_NO_2NDFLASH)
#define INCLUDE_HW_2NDFLASH
#endif

/* init + system initialization */
#define INCLUDE_INIT_DO_SYSINIT

/* general software features */
#define INCLUDE_SW_RAS
#if defined(PROJECT_DAVOS44DSL) || defined(PROJECT_XI524) || defined(PROJECT_DAVOS44IAD)
#define INCLUDE_SW_RAS_BLUETOOTH
#endif

#if defined(PROJECT_K800)
#define INCLUDE_SW_DIALER_LED
#define INCLUDE_SW_ONLINE_LED
#define INCLUDE_SW_DIALER_STATUS
#endif

#if defined(PROJECT_T240) || defined(PROJECT_T444)
#define INCLUDE_SW_ANALOG_TRUNK_LED
#endif

#endif	/* _INC_compactdsl_conf_h_ */
