/*
 * Copyright (C) <2002-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * conf.h - include $PROJECT dependend configuration header
 * --------------------------------------------------------
 *
 * Initial Version	Thu Mar 14 12:27:05 CET 2002 - jse
 * Written
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */


#ifndef _INC_conf_h_
#define _INC_conf_h_

/* ************************************************************************** */
/* *** FEATURES ************************************************************* */

/* *** hardware setup ******************************************************* */

/* second flash for compactdsl */
#undef INCLUDE_HW_2NDFLASH

/* realtime clock for eumex820 */
#undef INCLUDE_HW_RTC_HT1381

/* p2001 mac controller */
#undef	INCLUDE_HW_ETH_MAC0
#undef	INCLUDE_HW_ETH_MAC1
#undef	INCLUDE_HW_ETH_MAC2
#undef	INCLUDE_HW_ETH_MAC3

/* ethernet phy's */
#undef INCLUDE_HW_PHY_NOPHY
#undef INCLUDE_HW_PHY_LU3X34FT
#undef INCLUDE_HW_PHY_AMD79C901
#undef INCLUDE_HW_PHY_AC104QF
#undef INCLUDE_HW_PHY_KS8721B
#undef INCLUDE_HW_PHY_M88E6060

/* *** init + system initialization ***************************************** */
#undef INCLUDE_INIT_DO_SYSINIT
#undef INCLUDE_INIT_LAYOUT_V2

/* *** general software features ******************************************** */
#undef INCLUDE_SW_RAS
#undef INCLUDE_SW_RAS_BLUETOOTH
#undef INCLUDE_SW_CAPI_TAPI_LICENCE
#undef INCLUDE_SW_DIALER_LED
#undef INCLUDE_SW_ANALOG_TRUNK_LED



/* ************************************************************************** */
/* *** INCLUDES ************************************************************* */

#if defined(PROJECT_FAMILY_COMPACTDSL)
#include "compactdsl/conf.h"
#endif

#if defined(PROJECT_FAMILY_MODULARDSL)
#include "modulardsl/conf.h"
#endif

#if defined(PROJECT_FAMILY_ROUTERMODUL)
#include "routermodul/conf.h"
#endif

#if defined(PROJECT_FAMILY_GATEWAYMODUL)
#include "gatewaymodul/conf.h"
#endif

#if defined(PROJECT_FAMILY_VOIPTEL)
#include "voiptel/conf.h"
#endif

#endif	/* _INC_conf_h_ */
