/*
 * Copyright (C) <2002-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * display.h - include $PROJECT dependend display header
 * -----------------------------------------------------
 *
 * Initial Version	Fri Feb 15 13:38:43 CET 2002 - jse
 * Written
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef _INC_display_h_
#define _INC_display_h_

#define _DISP_ID_MAGIC		0xa5000000
#define DISP_ID_system		(_DISP_ID_MAGIC + (1 << 8))
#define DISP_ID_isdn		(_DISP_ID_MAGIC + (2 << 8))
#define DISP_ID_isdn_state_l1	(_DISP_ID_MAGIC + (2 << 8) + 1)
#define DISP_ID_isdn_state	(_DISP_ID_MAGIC + (2 << 8) + 2)
#define DISP_ID_isdn_xmit	(_DISP_ID_MAGIC + (2 << 8) + 3)
#define DISP_ID_isdn_recv	(_DISP_ID_MAGIC + (2 << 8) + 4)
#define DISP_ID_isdn_isp	(_DISP_ID_MAGIC + (2 << 8) + 5)
#define DISP_ID_analog_trunk    (_DISP_ID_MAGIC + (2 << 8) + 6)

#define DISP_ID_dsl		(_DISP_ID_MAGIC + (3 << 8))
#define DISP_ID_dsl_state	(_DISP_ID_MAGIC + (3 << 8) + 1)
#define DISP_ID_ethernet	(_DISP_ID_MAGIC + (4 << 8))
#define DISP_ID_ethernet_state	(_DISP_ID_MAGIC + (4 << 8) + 1)
#define DISP_ID_ethernet_xmit	(_DISP_ID_MAGIC + (4 << 8) + 2)
#define DISP_ID_ethernet_recv	(_DISP_ID_MAGIC + (4 << 8) + 3)
#define DISP_ID_ethernet_coll	(_DISP_ID_MAGIC + (4 << 8) + 4)
#define DISP_ID_usb		(_DISP_ID_MAGIC + (5 << 8))
#define DISP_ID_usb_state	(_DISP_ID_MAGIC + (5 << 8) + 1)
#define DISP_ID_usb_xmit	(_DISP_ID_MAGIC + (5 << 8) + 2)
#define DISP_ID_usb_recv	(_DISP_ID_MAGIC + (5 << 8) + 3)
#define DISP_ID_bt		(_DISP_ID_MAGIC + (6 << 8))
#define DISP_ID_bt_state	(_DISP_ID_MAGIC + (6 << 8) + 1)
#define DISP_ID_bt_xmit		(_DISP_ID_MAGIC + (6 << 8) + 2)
#define DISP_ID_bt_recv		(_DISP_ID_MAGIC + (6 << 8) + 3)
#define DISP_ID_cf		(_DISP_ID_MAGIC + (7 << 8))
#define DISP_ID_cf_state	(_DISP_ID_MAGIC + (7 << 8) + 1)
#define DISP_ID_cf_read		(_DISP_ID_MAGIC + (7 << 8) + 2)
#define DISP_ID_cf_write	(_DISP_ID_MAGIC + (7 << 8) + 3)
#define DISP_ID_capi		(_DISP_ID_MAGIC + (8 << 8))
#define DISP_ID_capi_state	(_DISP_ID_MAGIC + (8 << 8) + 1)
#define DISP_ID_dialer		(_DISP_ID_MAGIC + (9 << 8))
#define DISP_ID_dialer_state	(_DISP_ID_MAGIC + (9 << 8) + 1)
#define DISP_ID_online		(_DISP_ID_MAGIC + (10 << 8))
#define DISP_ID_online_state	(_DISP_ID_MAGIC + (10 << 8) + 1)

#if defined(PROJECT_FAMILY_COMPACTDSL)
#include "compactdsl/display.h"
#endif

#if defined(PROJECT_FAMILY_MODULARDSL)
#include "modulardsl/display.h"
#endif

#if defined(PROJECT_FAMILY_ROUTERMODUL)
#include "routermodul/display.h"
#endif

#if defined(PROJECT_FAMILY_GATEWAYMODUL)
#include "gatewaymodul/display.h"
#endif

#if defined(PROJECT_FAMILY_VOIPTEL)
#include "voiptel/display.h"
#endif

#endif	/* _INC_display_h_ */
