/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * km_pppoe.h - kernel mode pppoe stuff
 * ------------------------------------
 *
 * Initial Version	Thu Aug  1 10:48:08 CEST 2002 - jse
 * Written
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef __INC_km_pppoe_h__
#define __INC_km_pppoe_h__

#ifdef __cplusplus
extern "C" {
#endif

/*****************************************************************************/
/*** INCLUDES ****************************************************************/

#if !defined(__KERNEL__)
#include <net/if.h>
#include <net/ethernet.h>
#define MY_IFNAMESIZE		IF_NAMESIZE
#else
#include <linux/if.h>
#include <linux/if_ether.h>
#define MY_IFNAMESIZE		IFNAMSIZ
#endif



/*****************************************************************************/
/*** DEFINES *****************************************************************/

#define ETH_P_PPPOE_DISCOVERY	0x8863
#define ETH_P_PPPOE_SESSION	0x8864
#define PPPOE_HLEN		6
#define PPP_HLEN		2

/* ioctl's - see linux/if_ppp.h and net/if_ppp.h */
#define SIOCSPPPOECFG		(SIOCDEVPRIVATE + 4)



/*****************************************************************************/
/*** TYPEDEFS ****************************************************************/

struct km_pppoe {
	char		ifname[MY_IFNAMESIZE];
	int		clamp_mss;
	unsigned short	session_id;
	void		*dev_void;
	struct ethhdr	eth_hdr;
#define my_eth		eth_hdr.h_dest
#define peer_eth	eth_hdr.h_source
};

struct pppoe_hdr {
	struct ethhdr	eth_hdr;
	unsigned char	type_version;
	unsigned char	code;
	unsigned short	session;
	unsigned short	length;
	unsigned char	payload[ETH_DATA_LEN-ETH_HLEN-PPPOE_HLEN];
} __attribute__ ((__packed__));

#ifdef __cplusplus
}
#endif
#endif	/* __INC_km_pppoe_h__ */
