/*
 * Copyright (C) <2002-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * conf.h - modularsl configuration header
 * ----------------------------------------
 *
 */

#ifndef _INC_modulardsl_conf_h_
#define _INC_modulardsl_conf_h_

/* ************************************************************************** */
/* *** HARDWARE REVISIONS *************************************************** */

/* Define supported hardware revisions */
#if defined(PROJECT_T484)
#define INCLUDE_HWID_T484
#define INCLUDE_HWREV_0

#elif defined(PROJECT_EUMEX820)
#define INCLUDE_HWID_EUMEX820
#define INCLUDE_HWREV_0
#define INCLUDE_HWREV_1

#else
#error UNKOWN PROJECT
#endif



/* ************************************************************************** */
/* *** ETHERNET ************************************************************* */

/* Define which units to be included */
#if defined(PROJECT_T484)
#define	INCLUDE_HW_ETH_MAC0
#define	INCLUDE_HW_ETH_MAC1

#elif defined(PROJECT_EUMEX820)
#define	INCLUDE_HW_ETH_MAC0
#endif

/* Define supported phy's */
#if defined(PROJECT_T484)
#define INCLUDE_HW_PHY_KS8721B

#elif defined(PROJECT_EUMEX820)
#define INCLUDE_HW_PHY_M88E6060
#endif

#if defined(INCLUDE_HW_PHY_M88E6060)
#define ELMEG_SKB_TAILROOM		4	/* Marvell EGRES trailer */
#endif



/* ************************************************************************** */
/* *** FEATURES ************************************************************* */

/* hardware setup */
#define INCLUDE_HW_RTC_HT1381

/* init + system initialization */
#define INCLUDE_INIT_DO_SYSINIT

/* general software features */
#define INCLUDE_SW_RAS


#if defined(PROJECT_T484)
#define INCLUDE_SW_ANALOG_TRUNK_LED
#endif

#endif	/* _INC_modulardsl_conf_h_ */
