/*
 * Copyright (C) <2004-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Nils Goesche (nils.goesche@funkwerk-ec.com)
 *
 * mpsdev.h - mpsdev header 
 * ------------------------
 *
 * Initial Version	Tue Dec 14 18:56:38 CET 2004 - jse
 * Written
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef _INC_mpsdev_priv_h_
#define _INC_mpsdev_priv_h_

/* ************************************************************************* */
/* *** INCLUDES ************************************************************ */

#ifndef MPSDEV_H_INLCUDED__
#define MPSDEV_H_INLCUDED__

/*
 * Zum Anmelden am MPS Device.
 */
#define MPSIOCTL_SETID 42

/* 
 * Generell wird davon ausgegangen, dasz die Messages so aussehen, wie
 * in der MPS ueblich: Wenn eine Nachricht also etwa 30 Bytes Daten
 * enthalten soll, macht man ein kmalloc(sizeof(t_msg) + 30, GFP_KERNEL),
 * kopiert die Daten dann aber nicht direkt hinter den
 * Header t_msg, sondern schon auf &msg.data, das letzte Element von
 * t_msg.  msg.length setzt man auf 30.
 *
 * Mit send_mps_msg kann man der MPS eine Elmops-Nachricht schicken.
 * Die Nachricht musz mit kmalloc alloziert worden sein,
 * da das mps device sie mit kfree(msg) wieder freigibt!
 */
extern int mpsdev_send_msg( t_msg * );

/* Wenn man das nicht moechte, kann man auch einen festen t_msg buffer
 * verwenden.  Um mitzubekommen, wenn die Nachricht versendet wurde,
 * gibt man dann eine callback Funktion f an, die mit einem beliebigen
 * Argument arg aufgerufen wird, wenn die Nachricht versendet wurde.
 * Dann kann der Buffer wiederverwendet werden.
 */
extern int mpsdev_send_msg_notify( t_msg *,void (*)(void *),void * );



#endif	/* _INC_mpsdev_priv_h_ */
