/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef ASIC1_H
#define ASIC1_H

#define Adr_Highway_A_Control 		  0x2000
#define Adr_Highway_A_Timeslot_Enable 		  0x2004
#define Adr_Highway_A_Status 		  0x2008
#define Adr_Highway_B_Control 		  0x2010
#define Adr_Highway_B_Timeslot_Enable 		  0x2014
#define Adr_Highway_B_Status 		  0x2018
#define Adr_Highway_C_Control 		  0x2020
#define Adr_Highway_C_Timeslot_Enable 		  0x2024
#define Adr_Highway_C_Status 		  0x2028
#define Adr_Highway_D_Control 		  0x2030
#define Adr_Highway_D_Timeslot_Enable 		  0x2034
#define Adr_Highway_D_Status 		  0x2038
#define Adr_Highway_E_Control 		  0x2040
#define Adr_Highway_E_Timeslot_Enable 		  0x2044
#define Adr_Highway_E_Status 		  0x2048
#define Adr_Highway_F_Control 		  0x2050
#define Adr_Highway_F_Timeslot_Enable 		  0x2054
#define Adr_Highway_F_Status 		  0x2058
#define Adr_Highway_G_Control 		  0x2060
#define Adr_Highway_G_Timeslot_Enable 		  0x2064
#define Adr_Highway_G_Status 		  0x2068
#define Adr_Highway_H_Control 		  0x2070
#define Adr_Highway_H_Timeslot_Enable 		  0x2074
#define Adr_Highway_H_Status 		  0x2078
#define Adr_HDLC_WB_Control 		  0x2080
#define Adr_HDLC_WB_Status 		  0x2084
#define Adr_DTMF_WB_Control 		  0x2090
#define Adr_DTMF_WB_Status 		  0x2094
#define Adr_Peripheral_Frame_Sync_0 		  0x20a0
#define Adr_Peripheral_Frame_Sync_1 		  0x20a4
#define Adr_Peripheral_Frame_Sync_2 		  0x20a8
#define Adr_Peripheral_Frame_Sync_3 		  0x20ac
#define Adr_BSCK_FSC_Select 		  0x20b0
#define Adr_USB_FUNC_ADDR 		  0x0
#define Adr_USB_MODE_CTRL 		  0x4
#define Adr_USB_CTRL 		  0x8
#define Adr_USB_MAIN_EVENT 		  0xc
#define Adr_USB_MAIN_EVENT_MSK 		  0x10
#define Adr_USB_STATIC_EVENT 		  0x14
#define Adr_USB_STATIC_EVENT_MSK 		  0x18
#define Adr_USB_FRM_TIMER 		  0x1c
#define Adr_USB_OUT_EP_SEL 		  0x20
#define Adr_USB_OUT_DATA 		  0x24
#define Adr_USB_OUT_CMD 		  0x28
#define Adr_USB_OUT_STAT 		  0x2c
#define Adr_USB_IN_EP_SEL 		  0x30
#define Adr_USB_IN_DATA 		  0x34
#define Adr_USB_IN_CMD 		  0x38
#define Adr_USB_OEP_ENA 		  0x40
#define Adr_USB_IEP_ENA 		  0x44
#define Adr_USB_OEP_STALL 		  0x48
#define Adr_USB_IEP_STALL 		  0x4c
#define Adr_USB_OUT_EVENT 		  0x50
#define Adr_USB_OUT_EVENT_MSK 		  0x54
#define Adr_USB_IN_EVENT 		  0x58
#define Adr_USB_IN_EVENT_MSK 		  0x5c
#define Adr_USB_IN_ISO_CONF_REG 		  0x60
#define Adr_USB_OUT_ISO_CONF_REG 		  0x64
#define Adr_USB_IN_PTR_REG 		  0x68
#define Adr_USB_OUT_PTR_REG 		  0x6c
#define Adr_USB_CTRL_REG 		  0x7c
#define Adr_USB_EP0IN 		  0x0
#define Adr_USB_EP1IN 		  0x40
#define Adr_USB_EP2IN 		  0x80
#define Adr_USB_EP3IN 		  0xc0
#define Adr_USB_EP4IN 		  0x100
#define Adr_USB_EP5IN 		  0x140
#define Adr_USB_EP0OUT 		  0x180
#define Adr_USB_EP1OUT 		  0x1c0
#define Adr_USB_EP2OUT 		  0x200
#define Adr_USB_EP3OUT 		  0x240
#define Adr_USB_EP4OUT 		  0x280
#define Adr_USB_EP5OUT 		  0x2c0
#define Adr_ArmDmaPri 		  0xc
#define Adr_SDRAM_Ctrl 		  0x10
#define Adr_ExtMem_Ctrl 		  0x14
#define Adr_WaitState_Ext 		  0x18
#define Adr_WaitState_Asic 		  0x1c
#define Adr_TOP 		  0x20
#define Adr_Adr1_EQ_30Bit 		  0x30
#define Adr_Adr2_EQ_30Bit 		  0x34
#define Adr_Adr3_EQ_30Bit 		  0x38
#define Adr_Dat3_EQ_32Bit 		  0x3c
#define Adr_Adr4_HE_20Bit 		  0x40
#define Adr_Adr4_LT_20Bit 		  0x44
#define Adr_Adr5_HE_20Bit 		  0x48
#define Adr_Adr5_LT_20Bit 		  0x4c
#define Adr_Adr_Control 		  0x50
#define Adr_ABORT_IA_32Bit 		  0x54
#define Adr_Main_NFIQ_Int_Ctrl 		  0x0
#define Adr_Main_NIRQ_Int_Ctrl 		  0x4
#define Adr_Status_NFIQ 		  0x8
#define Adr_Status_NIRQ 		  0xc
#define Adr_Timer1 		  0x0
#define Adr_Timer2 		  0x4
#define Adr_TIMER_PRELOAD 		  0x8
#define Adr_Timer12_PreDiv 		  0xc
#define Adr_TIMER_INT 		  0x10
#define Adr_Freerun_Timer 		  0x14
#define Adr_WatchDog_Timer 		  0x18
#define Adr_PWM_CNT 		  0x20
#define Adr_PWM_CNT2 		  0x24
#define Adr_PLL_12000_config 		  0x30
#define Adr_PLL_12288_config 		  0x34
#define Adr_DIV_12288_config 		  0x38
#define Adr_MOD_CNT_768 		  0x3c
#define Adr_FSC_IRQ_STATUS 		  0x40
#define Adr_FSC_CONFIG 		  0x44
#define Adr_FSC_CONSTRUCT 		  0x48
#define Adr_FSC_base_clk_reg 		  0x4c
#define Adr_SYSCLK_SHAPE 		  0x50
#define Adr_SDRAMCLK_SHAPE 		  0x54
#define Adr_RING_OSZI 		  0x58
#define Adr_GPIO_Config 		  0x14
#define Adr_GPIO_INT 		  0x18
#define Adr_GPIO_Out 		  0x1c
#define Adr_GPIO_IN 		  0x20
#define Adr_GPIO_En 		  0x24
#define Adr_PIN_MUX 		  0x28
#define Adr_NRES_OUT 		  0x2c
#define Adr_GPIO2_Out 		  0x30
#define Adr_GPIO2_IN 		  0x34
#define Adr_GPIO2_En 		  0x38
#define Adr_GPIO_INT_SEL 		  0x3c
#define Adr_GPI3_IN 		  0x40
#define Adr_GPO4_OUT 		  0x44
#define Adr_Uart_TX1 		  0x0
#define Adr_Uart_TX2 		  0x4
#define Adr_Uart_TX3 		  0x8
#define Adr_Uart_TX4 		  0xc
#define Adr_Uart_Baudrate 		  0x10
#define Adr_Uart_Config 		  0x20
#define Adr_Uart_Clear 		  0x24
#define Adr_Uart_Echo_EN 		  0x28
#define Adr_Uart_RX1 		  0x0
#define Adr_Uart_RX2 		  0x4
#define Adr_Uart_RX3 		  0x8
#define Adr_Uart_RX4 		  0xc
#define Adr_Uart_PRE_STATUS 		  0x20
#define Adr_Uart_STATUS 		  0x24
#define Adr_Uart_IRQ_Status 		  0x2c
#define Adr_S0_B1_REC 		  0x0
#define Adr_S0_B1_SEND 		  0x4
#define Adr_S0_B2_REC 		  0x8
#define Adr_S0_B2_SEND 		  0xc
#define Adr_S0_D_REC 		  0x10
#define Adr_S0_D_SEND 		  0x14
#define Adr_S0_E_REC 		  0x18
#define Adr_S0_CTRL 		  0x1c
#define Adr_S0_INT_EN 		  0x20
#define Adr_S0_INT_STATUS 		  0x24
#define Adr_S0_FSC_PHASE 		  0x28
#define Adr_30_S0_STATES 		  0xc0
#define Adr_31_S0_SCTRL 		  0xc4
#define Adr_32_S0_SCTRL_E 		  0xc8
#define Adr_33_S0_SCTRL_R 		  0xcc
#define Adr_34_S0_SQ_REC_SEND 		  0xd0
#define Adr_37_S0_CLKDEL 		  0xdc
#define Adr_HDLC_dma_base0 		  0x0
#define Adr_HDLC_dma_base1 		  0x40
#define Adr_HDLC_dma_base2 		  0x80
#define Adr_HDLC_dma_base3 		  0xc0
#define Adr_HDLC_dma_base4 		  0x100
#define Adr_HDLC_dma_base5 		  0x140
#define Adr_HDLC_dma_base6 		  0x180
#define Adr_HDLC_dma_base7 		  0x1c0
#define Adr_HDLC_dma_base8 		  0x200
#define Adr_HDLC_dma_base9 		  0x240
#define Adr_HDLC_dma_base10 		  0x280
#define Adr_HDLC_dma_base11 		  0x2c0
#define Adr_HDLC_dma_base12 		  0x300
#define Adr_HDLC_dma_base13 		  0x340
#define Adr_HDLC_dma_base14 		  0x380
#define Adr_HDLC_dma_base15 		  0x3c0
#define Adr_HDLC_dma_base16 		  0x400
#define Adr_HDLC_dma_base17 		  0x440
#define Adr_HDLC_dma_base18 		  0x480
#define Adr_HDLC_dma_base19 		  0x4c0
#define Adr_HDLC_dma_base20 		  0x500
#define Adr_HDLC_dma_base21 		  0x540
#define Adr_HDLC_dma_base22 		  0x580
#define Adr_HDLC_dma_base23 		  0x5c0
#define Adr_HDLC_dma_base24 		  0x600
#define Adr_HDLC_dma_base25 		  0x640
#define Adr_HDLC_dma_base26 		  0x680
#define Adr_HDLC_dma_base27 		  0x6c0
#define Adr_HDLC_dma_base28 		  0x700
#define Adr_HDLC_dma_base29 		  0x740
#define Adr_HDLC_dma_base30 		  0x780
#define Adr_HDLC_dma_base31 		  0x7c0
#define Adr_HDLC_v_tx_dma_desc 		  0x0
#define Adr_HDLC_v_tx_dma_stat 		  0x8
#define Adr_HDLC_v_tx_dma_en 		  0xc
#define Adr_HDLC_v_rx_dma_desc 		  0x10
#define Adr_HDLC_v_rx_dma_cntl 		  0x14
#define Adr_HDLC_v_rx_dma_stat 		  0x18
#define Adr_HDLC_v_rx_dma_en 		  0x1c
#define Adr_HDLC_v_mode 		  0x20
#define Adr_HDLC_v_es_reg 		  0x24
#define Adr_HDLC_v_es_stat 		  0x28
#define Adr_HDLC_e00_base 		  0xe00
#define Adr_HDLC_pcm_cntl 		  0x10
#define Adr_HDLC_frame_end 		  0x18
#define Adr_HDLC_v_data_stat 		  0x1c
#define Adr_HDLC_v_err_stat 		  0x20
#define Adr_HDLC_rx_data 		  0x7f8
#define Adr_HDLC_rx_adr 		  0x7fc
#define Adr_HDLC_tx_data 		  0xff8
#define Adr_HDLC_tx_adr 		  0xffc
#define Adr_HDLC_mts_tsa_base 		  0x800
#define Adr_RMAC_DMA_DESC 		  0x0
#define Adr_RMAC_DMA_CNTL 		  0x4
#define Adr_RMAC_DMA_STAT 		  0x8
#define Adr_RMAC_DMA_EN 		  0xc
#define Adr_RMAC_CNTL 		  0x10
#define Adr_RMAC_TLEN 		  0x14
#define Adr_RMAC_PHYU 		  0x18
#define Adr_RMAC_PHYL 		  0x1c
#define Adr_RMAC_PFM0 		  0x20
#define Adr_RMAC_PFM1 		  0x24
#define Adr_RMAC_PFM2 		  0x28
#define Adr_RMAC_PFM3 		  0x2c
#define Adr_RMAC_PFM4 		  0x30
#define Adr_RMAC_PFM5 		  0x34
#define Adr_RMAC_PFM6 		  0x38
#define Adr_RMAC_PFM7 		  0x3c
#define Adr_RMAC_MIB0 		  0x40
#define Adr_RMAC_MIB1 		  0x44
#define Adr_RMAC_MIB2 		  0x48
#define Adr_RMAC_MIB3 		  0x4c
#define Adr_RMAC_MIB4 		  0x50
#define Adr_RMAC_MIB5 		  0x54
#define Adr_RMAC_DMA_DATA 		  0x7f8
#define Adr_RMAC_DMA_ADR 		  0x7fc
#define Adr_TMAC_DMA_DESC 		  0x800
#define Adr_TMAC_DMA_CNTL 		  0x804
#define Adr_TMAC_DMA_STAT 		  0x808
#define Adr_TMAC_DMA_EN 		  0x80c
#define Adr_TMAC_CNTL 		  0x810
#define Adr_TMAC_MIB6 		  0x814
#define Adr_TMAC_MIB7 		  0x818
#define Adr_MU_CNTL 		  0x820
#define Adr_MU_DATA 		  0x824
#define Adr_MU_DIV 		  0x828
#define Adr_CONF_RMII 		  0x82c
#define Adr_TMAC_DMA_DATA 		  0xff8
#define Adr_TMAC_DMA_ADR 		  0xffc
#define Adr_MAC_TABLE_LO_N 		  0x38
#define Adr_MAC_TABLE_HI_N 		  0x3c
#define Adr_COEF_1394_697 		  0x0
#define Adr_COEF_1540_770 		  0x4
#define Adr_COEF_1704_852 		  0x8
#define Adr_COEF_1882_941 		  0xc
#define Adr_COEF_2418_1209 		  0x10
#define Adr_COEF_2672_1336 		  0x14
#define Adr_COEF_2954_1477 		  0x18
#define Adr_COEF_3266_1633 		  0x1c
#define Adr_COEF_SIGNS 		  0x20
#define Adr_RECURSION_COUNTER 		  0x24
#define Adr_LAW_SCALE 		  0x28
#define Adr_MAG_TONE 		  0x40
#define Adr_MAG_OVERTONE 		  0x60
#define Adr_TAP1_TONE 		  0x80
#define Adr_TAP2_TONE 		  0x84
#define Adr_TAP1_OVERTONE 		  0xc0
#define Adr_TAP2_OVERTONE 		  0xc4
#define Adr_ENA_REG 		  0x2000
#define Adr_IRQ_STAT_REG 		  0x2004
#define Adr_MAC_CMP_VAL_LO 		  0x4000
#define Adr_MAC_CMP_VAL_HI 		  0x4004
#define Adr_MAC_CMP_RES 		  0x4008

#endif  /* ...ASIC1_H */
