/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef ASIC1_AB_H
#define ASIC1_AB_H

#define ABS_Adr_RAM_BASE 		  0x0
#define ABS_Adr_ROM_BASE 		  0x40000
#define ABS_Adr_Flash1_BASE 		  0x2000000
#define ABS_Adr_Flash2_BASE 		  0x4000000
#define ABS_Adr_Flash3_BASE 		  0x6000000
#define ABS_Adr_Flash4_BASE 		  0x8000000
#define ABS_Adr_SDRAM_BASE 		  0x40000000
#define ABS_Adr_SYS_BASE 		  0x100000
#define ABS_Adr_TIMER_BASE 		  0x110000
#define ABS_Adr_GPIO_BASE 		  0x120000
#define ABS_Adr_INT_CTRL_BASE 		  0x130000
#define ABS_Adr_UART_BASE 		  0x140000
#define ABS_Adr_PCM_HW_BASE 		  0x150000
#define ABS_Adr_Highway_A_S_BASE 		  0x150000
#define ABS_Adr_Highway_A_H_BASE 		  0x150100
#define ABS_Adr_Highway_B_S_BASE 		  0x150200
#define ABS_Adr_Highway_B_H_BASE 		  0x150300
#define ABS_Adr_Highway_C_S_BASE 		  0x150400
#define ABS_Adr_Highway_C_H_BASE 		  0x150500
#define ABS_Adr_Highway_D_S_BASE 		  0x150600
#define ABS_Adr_Highway_D_H_BASE 		  0x150700
#define ABS_Adr_Highway_E_S_BASE 		  0x150800
#define ABS_Adr_Highway_E_H_BASE 		  0x150900
#define ABS_Adr_Highway_F_S_BASE 		  0x150a00
#define ABS_Adr_Highway_F_H_BASE 		  0x150b00
#define ABS_Adr_Highway_G_S_BASE 		  0x150c00
#define ABS_Adr_Highway_G_H_BASE 		  0x150d00
#define ABS_Adr_Highway_H_S_BASE 		  0x150e00
#define ABS_Adr_Highway_H_H_BASE 		  0x150f00
#define ABS_Adr_HDLC_S_BASE 		  0x151000
#define ABS_Adr_HDLC_H_BASE 		  0x151100
#define ABS_Adr_DTMF_S_BASE 		  0x151200
#define ABS_Adr_DTMF_H_BASE 		  0x151300
#define ABS_Adr_Highway_A_Control 		  0x152000
#define ABS_Adr_Highway_A_Timeslot_Enable 		  0x152004
#define ABS_Adr_Highway_A_Status 		  0x152008
#define ABS_Adr_Highway_B_Control 		  0x152010
#define ABS_Adr_Highway_B_Timeslot_Enable 		  0x152014
#define ABS_Adr_Highway_B_Status 		  0x152018
#define ABS_Adr_Highway_C_Control 		  0x152020
#define ABS_Adr_Highway_C_Timeslot_Enable 		  0x152024
#define ABS_Adr_Highway_C_Status 		  0x152028
#define ABS_Adr_Highway_D_Control 		  0x152030
#define ABS_Adr_Highway_D_Timeslot_Enable 		  0x152034
#define ABS_Adr_Highway_D_Status 		  0x152038
#define ABS_Adr_Highway_E_Control 		  0x152040
#define ABS_Adr_Highway_E_Timeslot_Enable 		  0x152044
#define ABS_Adr_Highway_E_Status 		  0x152048
#define ABS_Adr_Highway_F_Control 		  0x152050
#define ABS_Adr_Highway_F_Timeslot_Enable 		  0x152054
#define ABS_Adr_Highway_F_Status 		  0x152058
#define ABS_Adr_Highway_G_Control 		  0x152060
#define ABS_Adr_Highway_G_Timeslot_Enable 		  0x152064
#define ABS_Adr_Highway_G_Status 		  0x152068
#define ABS_Adr_Highway_H_Control 		  0x152070
#define ABS_Adr_Highway_H_Timeslot_Enable 		  0x152074
#define ABS_Adr_Highway_H_Status 		  0x152078
#define ABS_Adr_HDLC_WB_Control 		  0x152080
#define ABS_Adr_HDLC_WB_Status 		  0x152084
#define ABS_Adr_DTMF_WB_Control 		  0x152090
#define ABS_Adr_DTMF_WB_Status 		  0x152094
#define ABS_Adr_Peripheral_Frame_Sync_0 		  0x1520a0
#define ABS_Adr_Peripheral_Frame_Sync_1 		  0x1520a4
#define ABS_Adr_Peripheral_Frame_Sync_2 		  0x1520a8
#define ABS_Adr_Peripheral_Frame_Sync_3 		  0x1520ac
#define ABS_Adr_BSCK_FSC_Select 		  0x1520b0
#define ABS_Adr_DTMF_BASE 		  0x160000
#define ABS_Adr_S0_BASE 		  0x170000
#define ABS_Adr_INBUS_BASE 		  0x180000
#define ABS_Adr_USB_REG_BASE 		  0x190000
#define ABS_Adr_USB_FUNC_ADDR 		  0x190000
#define ABS_Adr_USB_MODE_CTRL 		  0x190004
#define ABS_Adr_USB_CTRL 		  0x190008
#define ABS_Adr_USB_MAIN_EVENT 		  0x19000c
#define ABS_Adr_USB_MAIN_EVENT_MSK 		  0x190010
#define ABS_Adr_USB_STATIC_EVENT 		  0x190014
#define ABS_Adr_USB_STATIC_EVENT_MSK 		  0x190018
#define ABS_Adr_USB_FRM_TIMER 		  0x19001c
#define ABS_Adr_USB_OUT_EP_SEL 		  0x190020
#define ABS_Adr_USB_OUT_DATA 		  0x190024
#define ABS_Adr_USB_OUT_CMD 		  0x190028
#define ABS_Adr_USB_OUT_STAT 		  0x19002c
#define ABS_Adr_USB_IN_EP_SEL 		  0x190030
#define ABS_Adr_USB_IN_DATA 		  0x190034
#define ABS_Adr_USB_IN_CMD 		  0x190038
#define ABS_Adr_USB_OEP_ENA 		  0x190040
#define ABS_Adr_USB_IEP_ENA 		  0x190044
#define ABS_Adr_USB_OEP_STALL 		  0x190048
#define ABS_Adr_USB_IEP_STALL 		  0x19004c
#define ABS_Adr_USB_OUT_EVENT 		  0x190050
#define ABS_Adr_USB_OUT_EVENT_MSK 		  0x190054
#define ABS_Adr_USB_IN_EVENT 		  0x190058
#define ABS_Adr_USB_IN_EVENT_MSK 		  0x19005c
#define ABS_Adr_USB_IN_ISO_CONF_REG 		  0x190060
#define ABS_Adr_USB_OUT_ISO_CONF_REG 		  0x190064
#define ABS_Adr_USB_IN_PTR_REG 		  0x190068
#define ABS_Adr_USB_OUT_PTR_REG 		  0x19006c
#define ABS_Adr_USB_CTRL_REG 		  0x19007c
#define ABS_Adr_USB_FIFO_BASE 		  0x1a0000
#define ABS_Adr_USB_EP0IN 		  0x1a0000
#define ABS_Adr_USB_EP1IN 		  0x1a0040
#define ABS_Adr_USB_EP2IN 		  0x1a0080
#define ABS_Adr_USB_EP3IN 		  0x1a00c0
#define ABS_Adr_USB_EP4IN 		  0x1a0100
#define ABS_Adr_USB_EP5IN 		  0x1a0140
#define ABS_Adr_USB_EP0OUT 		  0x1a0180
#define ABS_Adr_USB_EP1OUT 		  0x1a01c0
#define ABS_Adr_USB_EP2OUT 		  0x1a0200
#define ABS_Adr_USB_EP3OUT 		  0x1a0240
#define ABS_Adr_USB_EP4OUT 		  0x1a0280
#define ABS_Adr_USB_EP5OUT 		  0x1a02c0
#define ABS_Adr_ArmDmaPri 		  0x10000c
#define ABS_Adr_SDRAM_Ctrl 		  0x100010
#define ABS_Adr_ExtMem_Ctrl 		  0x100014
#define ABS_Adr_WaitState_Ext 		  0x100018
#define ABS_Adr_WaitState_Asic 		  0x10001c
#define ABS_Adr_TOP 		  0x100020
#define ABS_Adr_Adr1_EQ_30Bit 		  0x100030
#define ABS_Adr_Adr2_EQ_30Bit 		  0x100034
#define ABS_Adr_Adr3_EQ_30Bit 		  0x100038
#define ABS_Adr_Dat3_EQ_32Bit 		  0x10003c
#define ABS_Adr_Adr4_HE_20Bit 		  0x100040
#define ABS_Adr_Adr4_LT_20Bit 		  0x100044
#define ABS_Adr_Adr5_HE_20Bit 		  0x100048
#define ABS_Adr_Adr5_LT_20Bit 		  0x10004c
#define ABS_Adr_Adr_Control 		  0x100050
#define ABS_Adr_ABORT_IA_32Bit 		  0x100054
#define ABS_Adr_Main_NFIQ_Int_Ctrl 		  0x130000
#define ABS_Adr_Main_NIRQ_Int_Ctrl 		  0x130004
#define ABS_Adr_Status_NFIQ 		  0x130008
#define ABS_Adr_Status_NIRQ 		  0x13000c
#define ABS_Adr_Timer1 		  0x110000
#define ABS_Adr_Timer2 		  0x110004
#define ABS_Adr_TIMER_PRELOAD 		  0x110008
#define ABS_Adr_Timer12_PreDiv 		  0x11000c
#define ABS_Adr_TIMER_INT 		  0x110010
#define ABS_Adr_Freerun_Timer 		  0x110014
#define ABS_Adr_WatchDog_Timer 		  0x110018
#define ABS_Adr_PWM_CNT 		  0x110020
#define ABS_Adr_PWM_CNT2 		  0x110024
#define ABS_Adr_PLL_12000_config 		  0x110030
#define ABS_Adr_PLL_12288_config 		  0x110034
#define ABS_Adr_DIV_12288_config 		  0x110038
#define ABS_Adr_MOD_CNT_768 		  0x11003c
#define ABS_Adr_FSC_IRQ_STATUS 		  0x110040
#define ABS_Adr_FSC_CONFIG 		  0x110044
#define ABS_Adr_FSC_CONSTRUCT 		  0x110048
#define ABS_Adr_FSC_base_clk_reg 		  0x11004c
#define ABS_Adr_SYSCLK_SHAPE 		  0x110050
#define ABS_Adr_SDRAMCLK_SHAPE 		  0x110054
#define ABS_Adr_RING_OSZI 		  0x110058
#define ABS_Adr_GPIO_Config 		  0x120014
#define ABS_Adr_GPIO_INT 		  0x120018
#define ABS_Adr_GPIO_Out 		  0x12001c
#define ABS_Adr_GPIO_IN 		  0x120020
#define ABS_Adr_GPIO_En 		  0x120024
#define ABS_Adr_PIN_MUX 		  0x120028
#define ABS_Adr_NRES_OUT 		  0x12002c
#define ABS_Adr_GPIO2_Out 		  0x120030
#define ABS_Adr_GPIO2_IN 		  0x120034
#define ABS_Adr_GPIO2_En 		  0x120038
#define ABS_Adr_GPIO_INT_SEL 		  0x12003c
#define ABS_Adr_GPI3_IN 		  0x120040
#define ABS_Adr_GPO4_OUT 		  0x120044
#define ABS_Adr_Uart_TX1 		  0x140000
#define ABS_Adr_Uart_TX2 		  0x140004
#define ABS_Adr_Uart_TX3 		  0x140008
#define ABS_Adr_Uart_TX4 		  0x14000c
#define ABS_Adr_Uart_Baudrate 		  0x140010
#define ABS_Adr_Uart_Config 		  0x140020
#define ABS_Adr_Uart_Clear 		  0x140024
#define ABS_Adr_Uart_Echo_EN 		  0x140028
#define ABS_Adr_Uart_RX1 		  0x140000
#define ABS_Adr_Uart_RX2 		  0x140004
#define ABS_Adr_Uart_RX3 		  0x140008
#define ABS_Adr_Uart_RX4 		  0x14000c
#define ABS_Adr_Uart_PRE_STATUS 		  0x140020
#define ABS_Adr_Uart_STATUS 		  0x140024
#define ABS_Adr_Uart_IRQ_Status 		  0x14002c
#define ABS_Adr_S01_BASE 		  0x170000
#define ABS_Adr_S02_BASE 		  0x170400
#define ABS_Adr_S0_B1_REC 		  0x170000
#define ABS_Adr_S0_B1_SEND 		  0x170004
#define ABS_Adr_S0_B2_REC 		  0x170008
#define ABS_Adr_S0_B2_SEND 		  0x17000c
#define ABS_Adr_S0_D_REC 		  0x170010
#define ABS_Adr_S0_D_SEND 		  0x170014
#define ABS_Adr_S0_E_REC 		  0x170018
#define ABS_Adr_S0_CTRL 		  0x17001c
#define ABS_Adr_S0_INT_EN 		  0x170020
#define ABS_Adr_S0_INT_STATUS 		  0x170024
#define ABS_Adr_S0_FSC_PHASE 		  0x170028
#define ABS_Adr_30_S0_STATES 		  0x1700c0
#define ABS_Adr_31_S0_SCTRL 		  0x1700c4
#define ABS_Adr_32_S0_SCTRL_E 		  0x1700c8
#define ABS_Adr_33_S0_SCTRL_R 		  0x1700cc
#define ABS_Adr_34_S0_SQ_REC_SEND 		  0x1700d0
#define ABS_Adr_37_S0_CLKDEL 		  0x1700dc
#define ABS_Adr_HDLC_BASE 		  0x184000
#define ABS_Adr_HDLC_dma_base0 		  0x184000
#define ABS_Adr_HDLC_dma_base1 		  0x184040
#define ABS_Adr_HDLC_dma_base2 		  0x184080
#define ABS_Adr_HDLC_dma_base3 		  0x1840c0
#define ABS_Adr_HDLC_dma_base4 		  0x184100
#define ABS_Adr_HDLC_dma_base5 		  0x184140
#define ABS_Adr_HDLC_dma_base6 		  0x184180
#define ABS_Adr_HDLC_dma_base7 		  0x1841c0
#define ABS_Adr_HDLC_dma_base8 		  0x184200
#define ABS_Adr_HDLC_dma_base9 		  0x184240
#define ABS_Adr_HDLC_dma_base10 		  0x184280
#define ABS_Adr_HDLC_dma_base11 		  0x1842c0
#define ABS_Adr_HDLC_dma_base12 		  0x184300
#define ABS_Adr_HDLC_dma_base13 		  0x184340
#define ABS_Adr_HDLC_dma_base14 		  0x184380
#define ABS_Adr_HDLC_dma_base15 		  0x1843c0
#define ABS_Adr_HDLC_dma_base16 		  0x184400
#define ABS_Adr_HDLC_dma_base17 		  0x184440
#define ABS_Adr_HDLC_dma_base18 		  0x184480
#define ABS_Adr_HDLC_dma_base19 		  0x1844c0
#define ABS_Adr_HDLC_dma_base20 		  0x184500
#define ABS_Adr_HDLC_dma_base21 		  0x184540
#define ABS_Adr_HDLC_dma_base22 		  0x184580
#define ABS_Adr_HDLC_dma_base23 		  0x1845c0
#define ABS_Adr_HDLC_dma_base24 		  0x184600
#define ABS_Adr_HDLC_dma_base25 		  0x184640
#define ABS_Adr_HDLC_dma_base26 		  0x184680
#define ABS_Adr_HDLC_dma_base27 		  0x1846c0
#define ABS_Adr_HDLC_dma_base28 		  0x184700
#define ABS_Adr_HDLC_dma_base29 		  0x184740
#define ABS_Adr_HDLC_dma_base30 		  0x184780
#define ABS_Adr_HDLC_dma_base31 		  0x1847c0
#define ABS_Adr_HDLC_e00_base 		  0x184e00
#define ABS_Adr_HDLC_pcm_cntl 		  0x184e10
#define ABS_Adr_HDLC_frame_end 		  0x184e18
#define ABS_Adr_HDLC_v_data_stat 		  0x184e1c
#define ABS_Adr_HDLC_v_err_stat 		  0x184e20
#define ABS_Adr_HDLC_rx_data 		  0x1847f8
#define ABS_Adr_HDLC_rx_adr 		  0x1847fc
#define ABS_Adr_HDLC_tx_data 		  0x184ff8
#define ABS_Adr_HDLC_tx_adr 		  0x184ffc
#define ABS_Adr_HDLC_mts_tsa_base 		  0x184800
#define ABS_Adr_EU0_BASE 		  0x180000
#define ABS_Adr_EU1_BASE 		  0x181000
#define ABS_Adr_EU2_BASE 		  0x182000
#define ABS_Adr_EU3_BASE 		  0x183000
#define ABS_Adr_RMAC_DMA_DESC 		  0x0
#define ABS_Adr_RMAC_DMA_CNTL 		  0x4
#define ABS_Adr_RMAC_DMA_STAT 		  0x8
#define ABS_Adr_RMAC_DMA_EN 		  0xc
#define ABS_Adr_RMAC_CNTL 		  0x10
#define ABS_Adr_RMAC_TLEN 		  0x14
#define ABS_Adr_RMAC_PHYU 		  0x18
#define ABS_Adr_RMAC_PHYL 		  0x1c
#define ABS_Adr_RMAC_PFM0 		  0x20
#define ABS_Adr_RMAC_PFM1 		  0x24
#define ABS_Adr_RMAC_PFM2 		  0x28
#define ABS_Adr_RMAC_PFM3 		  0x2c
#define ABS_Adr_RMAC_PFM4 		  0x30
#define ABS_Adr_RMAC_PFM5 		  0x34
#define ABS_Adr_RMAC_PFM6 		  0x38
#define ABS_Adr_RMAC_PFM7 		  0x3c
#define ABS_Adr_RMAC_MIB0 		  0x40
#define ABS_Adr_RMAC_MIB1 		  0x44
#define ABS_Adr_RMAC_MIB2 		  0x48
#define ABS_Adr_RMAC_MIB3 		  0x4c
#define ABS_Adr_RMAC_MIB4 		  0x50
#define ABS_Adr_RMAC_MIB5 		  0x54
#define ABS_Adr_RMAC_DMA_DATA 		  0x7f8
#define ABS_Adr_RMAC_DMA_ADR 		  0x7fc
#define ABS_Adr_TMAC_DMA_DESC 		  0x800
#define ABS_Adr_TMAC_DMA_CNTL 		  0x804
#define ABS_Adr_TMAC_DMA_STAT 		  0x808
#define ABS_Adr_TMAC_DMA_EN 		  0x80c
#define ABS_Adr_TMAC_CNTL 		  0x810
#define ABS_Adr_TMAC_MIB6 		  0x814
#define ABS_Adr_TMAC_MIB7 		  0x818
#define ABS_Adr_MU_CNTL 		  0x820
#define ABS_Adr_MU_DATA 		  0x824
#define ABS_Adr_MU_DIV 		  0x828
#define ABS_Adr_CONF_RMII 		  0x82c
#define ABS_Adr_TMAC_DMA_DATA 		  0xff8
#define ABS_Adr_TMAC_DMA_ADR 		  0xffc
#define ABS_Adr_MAC_TABLE_LO_N 		  0x38
#define ABS_Adr_MAC_TABLE_HI_N 		  0x3c
#define ABS_Adr_COEF_1394_697 		  0x0
#define ABS_Adr_COEF_1540_770 		  0x4
#define ABS_Adr_COEF_1704_852 		  0x8
#define ABS_Adr_COEF_1882_941 		  0xc
#define ABS_Adr_COEF_2418_1209 		  0x10
#define ABS_Adr_COEF_2672_1336 		  0x14
#define ABS_Adr_COEF_2954_1477 		  0x18
#define ABS_Adr_COEF_3266_1633 		  0x1c
#define ABS_Adr_COEF_SIGNS 		  0x20
#define ABS_Adr_RECURSION_COUNTER 		  0x24
#define ABS_Adr_LAW_SCALE 		  0x28
#define ABS_Adr_MAG_TONE 		  0x40
#define ABS_Adr_MAG_OVERTONE 		  0x60
#define ABS_Adr_TAP1_TONE 		  0x80
#define ABS_Adr_TAP2_TONE 		  0x84
#define ABS_Adr_TAP1_OVERTONE 		  0xc0
#define ABS_Adr_TAP2_OVERTONE 		  0xc4
#define ABS_Adr_ENA_REG 		  0x162000
#define ABS_Adr_IRQ_STAT_REG 		  0x162004
#define ABS_Adr_MAC_CMP_VAL_LO 		  0x164000
#define ABS_Adr_MAC_CMP_VAL_HI 		  0x164004
#define ABS_Adr_MAC_CMP_RES 		  0x164008

#endif  /* ...ASIC1_AB_H */
