/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef P2001_REG_ADAPT_H
#define P2001_REG_ADAPT_H


/*
FILE CONTENTS

*/


/* Base-Addresses */

#define Adr_Uart			ABS_Adr_UART_BASE


#define Adr_ROM				ABS_Adr_ROM_BASE
#define Adr_Flash1			ABS_Adr_Flash1_BASE
#define Adr_SDRAM			ABS_Adr_SDRAM_BASE


#define Adr_S0_HDLC			ABS_Adr_S01_BASE
//#define Adr_S0_HDLC			ABS_Adr_S02_BASE

/* Control */

//#define ABS_Adr_Main_NFIQ_Int_Ctrl	Adr_Main_NFIQ_Int_Ctrl
//#define ABS_Adr_Main_NIRQ_Int_Ctrl	Adr_Main_NIRQ_Int_Ctrl
//#define ABS_Adr_Status_NFIQ		Adr_Status_NFIQ
//#define ABS_Adr_Status_NIRQ		Adr_Status_NIRQ


/* Timer */

#define ABS_Adr_Timer12_PreDiv_24Bit	ABS_Adr_Timer12_PreDiv
#define ABS_Adr_TIMER_INT_16bit		ABS_Adr_TIMER_INT
#define ABS_Adr_TIMER_PRELOAD_32bit	ABS_Adr_TIMER_PRELOAD

#define ABS_Adr_PWM_CNT_32bit		ABS_Adr_PWM_CNT


/* GPIO */

#define ABS_Adr_GPIO_Config_32bit	ABS_Adr_GPIO_Config
#define ABS_Adr_GPIO_INT_32bit		ABS_Adr_GPIO_INT
#define ABS_Adr_GPIO_Out_32bit		ABS_Adr_GPIO_Out
#define ABS_Adr_GPIO_IN_16bit		ABS_Adr_GPIO_IN
#define ABS_Adr_GPIO_En_16bit		ABS_Adr_GPIO_En


/* FSC */

#define ABS_Adr_FSC_IRQ_STATUS_11bit	ABS_Adr_FSC_IRQ_STATUS
#define ABS_Adr_FSC_CONFIG_17bit	ABS_Adr_FSC_CONFIG
#define ABS_Adr_FSC_CONSTRUCT_26bit	ABS_Adr_FSC_CONSTRUCT



/* UART */
 
#define AdrUartSendeRegister1 		0x00
#define AdrUartSendeRegister2		0x04
#define AdrUartSendeRegister3		0x08
#define AdrUartSendeRegister4	 	0x0c
#define AdrUartBaudrate			0x10
#define AdrUartConfigRegister	 	0x20
#define AdrUartClearRegister	  	0x24
#define AdrUartHardwareEcho		0x28
#define AdrUartEmpfangsRegister1	0x00
#define AdrUartEmpfangsRegister2	0x04
#define AdrUartEmpfangsRegister3	0x08
#define AdrUartEmpfangsRegister4	0x0c
#define AdrUartVorsUndStatusRegister	0x20
#define AdrUartStatusRegister	    	0x24
#define AdrUart_IQR_StatusConfig_20bit	0x2C


#endif /* ...P2001_REG_ADAPT_H */
