/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * arpping.h
 * ---------
 *
 * Initial Version	Thu Mar 28 14:53:48 CET 2002 - jse
 * Rewritten based on uDhcpd
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef _INC_arpping_h_
#define _INC_arpping_h_

/* ************************************************************************* */
/* *** INCLUDES ************************************************************ */

#include <netinet/if_ether.h>
#include <net/if_arp.h>
#include <net/if.h>
#include <netinet/in.h>



/* ************************************************************************* */
/* *** DEFINES ************************************************************* */

#define MAC_BCAST_ADDR	"\xff\xff\xff\xff\xff\xff"



/* ************************************************************************* */
/* *** TYPEDEFS ************************************************************ */

struct arpMsg {
	struct ethhdr ethhdr; 	/* Ethernet header */
	u_short htype;		/* hardware type (must be ARPHRD_ETHER) */
	u_short ptype;		/* protocol type (must be ETH_P_IP) */
	u_char  hlen;		/* hardware address length (must be 6) */
	u_char  plen;		/* protocol address length (must be 4) */
	u_short operation;	/* ARP opcode */
	u_char  sHaddr[6];	/* sender's hardware address */
	u_char  sInaddr[4];	/* sender's IP address */
	u_char  tHaddr[6];	/* target's hardware address */
	u_char  tInaddr[4];	/* target's IP address */
	u_char  pad[18];	/* pad for min. Ethernet payload (60 bytes) */
} __attribute__ ((packed));

struct ifinfo {
    char ifname[IFNAMSIZ];
    u_long addr;		/* network byte order */
    u_long mask;		/* network byte order */
    u_long bcast;		/* network byte order */
    u_char haddr[6];
    short flags;
} __attribute__ ((packed));



/* ************************************************************************* */
/* *** PROTOTYPES ********************************************************** */

extern int	arpping( u_int32_t,u_int32_t,char *,char *);
extern int	openRawSocket( int *,u_short );

#endif	/* _INC_arpping_h_ */
