/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * debug.h
 * -------
 *
 * Initial Version	Thu Mar 28 14:53:48 CET 2002 - jse
 * Written
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef _INC_debug_h_
#define _INC_debug_h_

/* ************************************************************************* */
/* *** INCLUDES ************************************************************ */

#include <stdio.h>
#ifdef WITH_SYSLOG
#include <syslog.h>
#endif



/* ************************************************************************* */
/* *** SYSLOG/DEBUG DEFINES ************************************************ */

#if defined(WITH_SYSLOG)

#define OPENLOG( ident,option,facility )	\
	openlog( ident,option,facility )
#define CLOSELOG()				\
	closelog()
#define LOG(fmt,args...)			\
	do { syslog( LOG_NOTICE,"[MSG] "/**/fmt,##args ); } while(0);
#define ERR(fmt,args...)			\
	do { syslog( LOG_ERR,"[ERR] "/**/fmt,##args ); } while(0);
#define WRN(fmt,args...)			\
	do { syslog( LOG_WARNING,"[WRN] "/**/fmt,##args ); } while(0);
#if 1
#define INF(fmt,args...)
#define DEB(fmt,args...)
#else
#define INF(fmt,args...)			\
	do { syslog( LOG_INFO,"[INF] "/**/fmt,##args ); } while(0);
#define DEB(fmt,args...)			\
	do { syslog( LOG_DEBUG,"[DEB] "/**/fmt,##args ); } while(0);
#endif

#else

#define OPENLOG( a,b,c )
#define CLOSELOG()
#define LOG(fmt,args...)			\
	do { printf( "dhcpd: [MSG] "/**/fmt,##args ); } while(0);
#define ERR(fmt,args...)			\
	if (debugLevel > 0) { printf( "dhcpd: [ERR] "/**/fmt,##args ); }
#define WRN(fmt,args...)			\
	if (debugLevel > 1) { printf( "dhcpd: [WRN] "/**/fmt,##args ); }
#define INF(fmt,args...)			\
	if (debugLevel > 2) { printf( "dhcpd: [INF] "/**/fmt,##args ); }
#define DEB(fmt,args...)			\
	if (debugLevel > 3) { printf( "dhcpd: [DEB] "/**/fmt,##args ); }

#endif

#endif	/* _INC_debug_h_ */
