/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * msh.h
 * -----
 *
 * Initial Version	Mon Apr 29 14:47:24 CEST 2002 - jse
 * Written
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef __INC_msh_h_
#define __INC_msh_h_

/* ************************************************************************* */
/* *** INCLUDES ************************************************************ */

#include <features.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/ioctl.h>
#include <sys/dir.h>
#include <sys/times.h>
#include <sys/signal.h>
#include <sys/param.h> 
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include <signal.h>
#include <errno.h>
#include <setjmp.h>
#include <stddef.h>
#include <time.h>
#include <limits.h>
#include <syslog.h>



/* ************************************************************************* */
/* *** FEATURES ************************************************************ */

#define BB_FEATURE_COMMAND_EDITING
#define BB_FEATURE_SH_STANDALONE_SHELL
#undef BB_LOCALE_SUPPORT
#undef BB_FEATURE_COMMAND_TAB_COMPLETION
#undef BB_FEATURE_COMMAND_USERNAME_COMPLETION
#undef BB_FEATURE_NONPRINTABLE_INVERSE_PUT
#undef BB_FEATURE_CLEAN_UP
#undef BB_FEATURE_SH_FANCY_PROMPT
#undef BB_FEATURE_SH_APPLETS_ALWAYS_WIN



/* ************************************************************************* */
/* *** DEFINES ************************************************************* */

#define RESERVE_BB_BUFFER(buffer,len)           char *buffer=malloc(len)
#define RESERVE_BB_UBUFFER(buffer,len) unsigned char *buffer=malloc(len)
#define RELEASE_BB_BUFFER(buffer)      free (buffer)

#ifndef PATH_MAX 
#define  PATH_MAX         256
#endif
#undef TRUE
#undef FALSE
#define TRUE ((int)1)
#define FALSE ((int)0)

/* Bit map related macros -- libc5 doens't provide these... sigh.  */
#ifndef setbit
#define NBBY            CHAR_BIT
#define setbit(a,i)     ((a)[(i)/NBBY] |= 1<<((i)%NBBY))
#define clrbit(a,i)     ((a)[(i)/NBBY] &= ~(1<<((i)%NBBY)))
#define isset(a,i)      ((a)[(i)/NBBY] & (1<<((i)%NBBY)))
#define isclr(a,i)      (((a)[(i)/NBBY] & (1<<((i)%NBBY))) == 0)
#endif

#define prs(s)			fputs( s,stderr )
#define put1c(c)		putc( c,stderr )
#define prn(u)			fputs( itoa(u,0),stderr )

/* ************************************************************************* */
/* *** PROTOTYPES ********************************************************** */

extern int		cmdedit_read_input(char* promptStr, char* command);
extern ssize_t	safe_read(int fd, void *buf, size_t count);
extern void		err(char *s);
extern int		test_main(int argc, char** argv);

#endif	/* __INC_msh_h_ */
