#ifndef TRIOPIO_H
#define TRIOPIO_H

#include <asm/arch-trio/hardware.h>
#define PIOA_ID 1
#define PIOB_ID 2
struct trioport{
	struct pio_regs *base;
	u_32 pio;
	u_32 pout;
	u_32 irq;
	u_32 irq_nb;
	u_32 pdout;
	u_32 pdin;
	u_32 inmask;
	u_32 outmask;
	u_32 id;
};
struct pio_handler{
	int id;
	int (*pio_interrupt)(struct trioport *, u_32);
	int priority;
	u_32 pa_mask;
	u_32 pb_mask;
	struct trioport *pa;
	struct trioport *pb;
	struct pio_handler *prev;
	struct pio_handler *next;
};
int pio_hook_driver(struct pio_handler* handler);
int pio_remove_driver(struct pio_handler *handler);

void trioport_out(struct trioport* p, u_32 value);
void trioport_io(struct trioport* p, u_32 mask, u_32 value);
void trioport_change_out(struct trioport* p, u_32 mask, u_32 value);
u_32 trioport_get_in(struct trioport *p);
int trioport_set_out(struct trioport *p, u_32 mask, u_32 value);
#endif

