/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH>
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#include <linux/config.h>
#include <asm/assembler.h>
#include <asm/hardware.h>
#include "p2001/arm9tdmi.h"
#include "bsp.h"

		.text
		.align 4


		.globl	__entry,_entry
		.globl	__stext,_stext
		.globl _start,start

start:
_start:
_stext:
_entry:
__stext:
__entry:
InitRemap:

	mov	r0, #(Mode_FIQ | I_Bit | F_Bit)
	msr	cpsr, r0
#if 1
	ldr	sp,=(SRAM_BASE_ADDR + SRAM_SIZE - 4)
#else
#warning FIQ_STACK MOVED
	ldr	sp,=(0x40800000 - 4)	/* XXX jse define */
#endif
							/* preserve HWID */

	mov	r0, #(Mode_SVR | I_Bit | F_Bit)
	msr	cpsr, r0

	adr	r5, LC1
	ldmia	r5, {r5, r6, r8}			@ Copy sram sec
2:	cmp	r6, r8
	ldrcc	r4, [r5],#4
	strcc	r4, [r6],#4
	bcc	2b

	adr	r5, LC0
	ldmia	r5, {r5, r6, r8, sp}			@ Setup stack
	mov	r4, #0
1:	cmp	r5, r8					@ Clear BSS
	strcc	r4, [r5],#4
	bcc	1b

	ldr r2,=0x41009000				@ arm_id XXX jse
	str r2,[r6]

	mov	fp, #0
	b	start_kernel

LC0:	.long	edata
	.long	arm_id
	.long	end
	.long	init_user_stack + 4096

LC1:	.long	end
	.long	_sram
	.long	_esram
