/*
 * linux/arch/arm/lib/getconstants.c
 *
 * Copyright (C) 1995, 1996 Russell King
 */

/*
 * Modifications for P2001 Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH>
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#if 0	/* jse */
#include <linux/mm.h>
#include <asm/pgtable.h>
#include <stdio.h>
#include <linux/unistd.h>
#else
#include <stdio.h>
#endif

void printdef(char *def, int no)
{
	printf("#define %s\t%d\n", def, no);
}

#include "getconstants.h"

int main()
{
	printf("/*\n *  contants.h generated by getconstants\n * DO NOT EDIT!\n */\n");

	printf("#define _current\t_%s\n", "current_set");

#ifdef _PAGE_PRESENT
	printdef("PAGE_PRESENT",	_PAGE_PRESENT);
#endif
#ifdef _PAGE_RW
	printdef("PAGE_RW",		_PAGE_RW);
#endif
#ifdef _PAGE_USER
	printdef("PAGE_USER",		_PAGE_USER);
#endif
#ifdef _PAGE_ACCESSED
	printdef("PAGE_ACCESSED",	_PAGE_ACCESSED);
#endif
#ifdef _PAGE_DIRTY
	printdef("PAGE_DIRTY",		_PAGE_DIRTY);
#endif
#ifdef _PAGE_READONLY
	printdef("PAGE_READONLY",	_PAGE_READONLY);
#endif
#ifdef _PAGE_NOT_USER
	printdef("PAGE_NOT_USER",	_PAGE_NOT_USER);
#endif
#ifdef _PAGE_OLD
	printdef("PAGE_OLD",		_PAGE_OLD);
#endif
#ifdef _PAGE_CLEAN
	printdef("PAGE_CLEAN",		_PAGE_CLEAN);
#endif
#ifdef __HAS_tss_memmap
	printdef("TSS_MEMMAP",		(int)tss_memmap);
#endif
#ifdef __HAS_tss_save
	printdef("TSS_SAVE",		(int)tss_save);
#endif
#ifdef __HAS_tss_memcmap
	printdef("TSS_MEMCMAP",		(int)tss_memcmap);
#endif
#ifdef __HAS_tss_fpesave
	printdef("TSS_FPESAVE",		(int)tss_fpesave);
#endif
#ifdef __HAS_mm
	printdef("MM",			(int)mm);
#endif
	
#ifdef __HAS_pgd
	printdef("PGD",			(int)pgd);
#endif

	printf("#define KSWI_BASE	0x900000\n");
	printf("#define KSWI_SYS_BASE	0x9F0000\n");
	printf("#define SYS_ERROR0	0x9F0000\n");
	return 0;
}
