/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * include/asm-arm/arch-p2001/irq.h
 * --------------------------------
 *
 * $RCSfile: irq.h,v $
 * $Source: /opt/funkwerk/cvsroot/source/linux/uclinux2.0.38/include/asm-armnommu/arch-p2001/irq.h,v $
 * $Author: jselent $
 * $Revision: 1.4 $
 * $Date: 2008-05-16 15:47:14 $
 * $State: Exp $
 * $Name:  $
 *
 * $Log: irq.h,v $
 * Revision 1.4  2008-05-16 15:47:14  jselent
 * CHG: copyright info
 *
 * Revision 1.3  2002-08-13 13:37:56  schaller
 * timer1 interrupt mapping changed from timer_IRQ_interrupt to IRQ_interrupt
 *
 * Revision 1.2  2002/08/06 14:19:45  selent
 * new build process
 *
 * Revision 1.1  2002/08/06 12:36:20  selent
 * imported
 *
 * Revision 1.2  2002/02/14 15:37:54  selent
 * *** empty log message ***
 *
 * Initial Version	Tue Sep  4 14:48:27 CEST 2001
 * Written
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef __ASM_ARM_ARCH_IRQ_H
#define __ASM_ARM_ARCH_IRQ_H

#define BUILD_IRQ(s,n,m)

struct pt_regs;

extern int IRQ_interrupt(int irq, struct pt_regs *regs);
extern int timer_IRQ_interrupt(int irq, struct pt_regs *regs);
extern int fast_IRQ_interrupt(int irq, struct pt_regs *regs);
extern int bad_IRQ_interrupt(int irq, struct pt_regs *regs);
extern int probe_IRQ_interrupt(int irq, struct pt_regs *regs);

#define IRQ_interrupt0 IRQ_interrupt
#define IRQ_interrupt1 IRQ_interrupt
#define IRQ_interrupt2 IRQ_interrupt
#define IRQ_interrupt3 IRQ_interrupt
#define IRQ_interrupt4 IRQ_interrupt
#define IRQ_interrupt5 IRQ_interrupt
#define IRQ_interrupt6 IRQ_interrupt
#define IRQ_interrupt7 IRQ_interrupt
#define IRQ_interrupt8 IRQ_interrupt
#define IRQ_interrupt9 IRQ_interrupt
#define IRQ_interrupt10 IRQ_interrupt
#define IRQ_interrupt11 IRQ_interrupt
#define IRQ_interrupt12 fast_IRQ_interrupt
#define IRQ_interrupt13 IRQ_interrupt
#define IRQ_interrupt14 IRQ_interrupt
#define IRQ_interrupt15 IRQ_interrupt
#define IRQ_interrupt16 IRQ_interrupt
#define IRQ_interrupt17 IRQ_interrupt
#define IRQ_interrupt18 timer_IRQ_interrupt
#define IRQ_interrupt19 IRQ_interrupt
#define IRQ_interrupt20 IRQ_interrupt
#define IRQ_interrupt21 IRQ_interrupt
#define IRQ_interrupt22 IRQ_interrupt
#define IRQ_interrupt23 IRQ_interrupt
#define IRQ_interrupt24 IRQ_interrupt
#define IRQ_interrupt25 IRQ_interrupt
#define IRQ_interrupt26 IRQ_interrupt

#define IRQ_INTERRUPT(n)	(void (*)(void))IRQ_interrupt##n
#define FAST_INTERRUPT(n)	(void (*)(void))fast_IRQ_interrupt
#define BAD_INTERRUPT(n)	(void (*)(void))bad_IRQ_interrupt
#define PROBE_INTERRUPT(n)	(void (*)(void))probe_IRQ_interrupt

extern const unsigned long irq_masks[32];

static __inline__ void mask_irq(unsigned int irq)
{
	p2001_int_t	*icntl = (p2001_int_t *) INTCNTL_BASE_ADDR;

	icntl->irq_cntl &= ~irq_masks[irq & 0x1F];
}

static __inline__ void unmask_irq(unsigned int irq)
{
	p2001_int_t	*icntl = (p2001_int_t *) INTCNTL_BASE_ADDR;

	icntl->irq_cntl |= irq_masks[irq & 0x1F];
}

static __inline__ unsigned long get_enabled_irqs(void)
{
	p2001_int_t	*icntl = (p2001_int_t *) INTCNTL_BASE_ADDR;
	unsigned long	reg;
	unsigned long	ret;
	int		i;

	reg = icntl->irq_cntl;
	ret = 0;
	for (i = 1; i <= NUMBER_OF_IRQS; i++) {
		if (reg & irq_masks[i])
			ret |= (1 << i);
	}
	return ret;
}

static __inline__ void irq_init_irq(void)
{
	extern void p2001_init_irqs(void);

	p2001_init_irqs();
}
#endif	/* __ASM_ARM_ARCH_IRQ_H */
