/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * linux/include/asm-armnommu/arch-p2001/irqs.h
 * --------------------------------------------
 *
 * $RCSfile: irqs.h,v $
 * $Source: /opt/funkwerk/cvsroot/source/linux/uclinux2.0.38/include/asm-armnommu/arch-p2001/irqs.h,v $
 * $Author: jselent $
 * $Revision: 1.3 $
 * $Date: 2008-05-16 15:47:14 $
 * $State: Exp $
 * $Name:  $
 *
 * $Log: irqs.h,v $
 * Revision 1.3  2008-05-16 15:47:14  jselent
 * CHG: copyright info
 *
 * Revision 1.2  2002-08-06 14:19:45  selent
 * new build process
 *
 * Revision 1.1  2002/08/06 12:36:20  selent
 * imported
 *
 * Revision 1.1.1.1  2001/10/23 17:36:40  selent
 * the new source tree
 *
 * Revision 1.1.1.1  2001/10/23 17:36:40  goesche
 * Vorlaeufiger Linux-Entwicklungsbaum
 *
 * Revision 1.3  2001/09/04 15:59:04  juergen
 * cleanup
 *
 * Initial Version	Tue Sep  4 17:21:45 CEST 2001
 * Written
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef _INC_irqs_h_
#define _INC_irqs_h_

/*
 *
 */

/* IRQS are mapped onto the following abstract numbers */

#define IRQ_USB		1
#define IRQ_UART	2
#define IRQ_PWM		3
#define IRQ_FSC		4
#define IRQ_GPIO	5
#define IRQ_PFS		6
#define IRQ_S0_1	7
#define IRQ_S0_2	8
#define IRQ_DTMF	9
#define IRQ_WATCHDOG	10
#define IRQ_PCMHW	11
#define IRQ_HDLC	12
#define IRQ_ETH_0	13
#define IRQ_ETH_1	14
#define IRQ_ETH_2	15
#define IRQ_ETH_3	16
#define IRQ_TC1		17
#define IRQ_TC2		18

#define NUMBER_OF_IRQS	18

#endif	/* _INC_irqs_h_ */
