/*
 * Copyright (C) <2001-2008> <Funkwerk Enterprise Communications GmbH> 
 * Written by Juergen Selent (juergen.selent@funkwerk-ec.com)
 *
 * include/asm-arm/arch-p2001/time.h
 * ---------------------------------
 *
 * $RCSfile: time.h,v $
 * $Source: /opt/funkwerk/cvsroot/source/linux/uclinux2.0.38/include/asm-armnommu/arch-p2001/time.h,v $
 * $Author: jselent $
 * $Revision: 1.8 $
 * $Date: 2008-05-16 15:47:14 $
 * $State: Exp $
 * $Name:  $
 *
 * $Log: time.h,v $
 * Revision 1.8  2008-05-16 15:47:14  jselent
 * CHG: copyright info
 *
 * Revision 1.7  2003-06-05 15:06:38  selent
 * HT1381 Real Time Clock
 *
 * Revision 1.6  2002/09/06 06:41:15  schaller
 * setup_timer fixed again
 *
 * Revision 1.5  2002/09/05 17:11:29  selent
 * 22.08.2001
 *
 * Revision 1.4  2002/09/02 08:20:18  schaller
 * fixed
 *
 * Revision 1.3  2002/09/02 08:18:48  schaller
 * clock runs too fast, so timer2 predivider fixed (it's a special p200x feature).
 * predivider has to be prediv -=1 =>191
 *
 * Revision 1.2  2002/08/06 14:19:45  selent
 * new build process
 *
 * Revision 1.1  2002/08/06 12:36:20  selent
 * imported
 *
 * Revision 1.3  2002/02/14 15:37:54  selent
 * *** empty log message ***
 *
 * Initial Version	Tue Sep  4 14:48:27 CEST 2001
 * Written
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS * FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * DISCLAIMER OF WARRANTY 
 *
 * THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY 
 * APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE 
 * COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" 
 * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY 
 * AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM 
 * PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
 * REPAIR OR CORRECTION. 
 *  
 * LIMITATION OF LIABILITY 
 *
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR 
 * CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
 * HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGES. 
 */

#ifndef __ASM_ARM_ARCH_TIME_H
#define __ASM_ARM_ARCH_TIME_H

extern __inline__ unsigned long gettimeoffset(void)
{
	volatile p2001_tm_t *tcntl = (volatile p2001_tm_t *) TIMER_BASE_ADDR;
	unsigned long count;
	unsigned long prediv;

	prediv = 192;
	count = SYSCLK/(prediv*100) - tcntl->timer2;
	return (count * 10000) / (SYSCLK/(prediv*100));
}

/*
 * No need to reset the timer at every irq
 */
extern __inline__ int reset_timer(void)
{
	return (1);
}

/*
 * Updating of the RTC.  We don't currently write the time to the
 * CMOS clock.
 */
#define update_rtc()

#endif	/* __ASM_ARM_ARCH_TIME_H */
