#include <asm/arch-trio/hardware.h>

struct triokb_piomask{
	u_32 pra_mask;
	u_32 prb_mask;
	u_32 pca_mask;
	u_32 pcb_mask;
};



enum {
	TRIOKB_PIOMASK,
	TRIOKB_STATUS,
	TRIOKB_HIT,
	TRIOKB_FLUSH,
	TRIOKB_AUTOREPEAT,				/* no more used */
	TRIOKB_KEYDURATION,				
	TRIOKB_SETBREAK,				/* no more used */
	TRIOKB_SET_KEY,					/* use an (skey *) as arg with the first 3 elements. Time values are in ms */
	TRIOKB_SET_AUTOREPEAT_DELAY,	/* set delay before autorepeat. In ms */
};

/* arg of TRIOKB_STATUS*/
struct triokb_status {
	unsigned int keys;				/* real time keys mask */
	unsigned int duration;			/*in ms*/
};

/* arg for TRIOKB_SET_KEY */
struct skey {
	unsigned int key_val;			/* code of the key. If 0, sets all the keys */
	unsigned int timeout;			/* key timeout event.	   set in ms. If 0 a default value is set (120 ms)*/
	unsigned int autorepeat;		/* autoreapeat time value. set in ms */
	unsigned int duration;			/*  */
};

/*psalou keys define returned by read*/
#define KEY_NAVY_DOWN	2
#define KEY_NAVY_UP		3
#define KEY_NAVY_LEFT	5
#define KEY_NAVY_RIGHT	6
#define KEY_EXT			7
#define KEY_ENTER		8
#define KEY_NUM_SPECIAL	9
#define KEY_FUNCTION	10
#define KEY_NETCALL		11
#define KEY_ALPHA		12

/*values returned in TRIOKB_STATUS */
/* 0 undefined */
#define MSK_NAVY_DOWN	((1)<<KEY_NAVY_DOWN)	
#define MSK_NAVY_UP		((1)<<KEY_NAVY_UP)
#define MSK_NAVY_LEFT	((1)<<KEY_NAVY_LEFT)	
#define MSK_NAVY_RIGHT	((1)<<KEY_NAVY_RIGHT)
#define MSK_KEY_EXT		((1)<<KEY_EXT)	
#define MSK_ENTER		((1)<<KEY_ENTER)	
#define MSK_NUM_SPECIAL	((1)<<KEY_NUM_SPECIAL)	
#define MSK_FUNCTION	((1)<<KEY_FUNCTION)
#define MSK_NETCALL		((1)<<KEY_NETCALL)	
#define MSK_ALPHA		((1)<<KEY_ALPHA)	

